#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "e2.h"

int main() {
    short buf[] = { 1, 1, 2, 3, 5, 8, 13, 21 };
    node_t *l;
    list_new(&l);
    printf("Risultato: %d [corretto: 0]\n", (unsigned)l);

    return 0;
}

int list_new_from_buffer(node_t **l, short* buf, int n){
    *l = NULL;
    while (--n >= 0)
        if (list_add_first(l, buf[n])) return 1;
    return 0;
}

void list_delete(node_t **l) {
    node_t *p = *l;
    for (;p != NULL; p=p->next) {
        node_t *dead = p;
        p = p->next;
        free(dead);
    }
    *l = NULL;
}

int list_add_first(node_t **l, short elem) {
    node_t *p = *l;
    node_t *n = malloc(sizeof(node_t));
    if (n == NULL) return -1;           // allocation error
    n->elem = elem;
    n->next = p;
    *l = n;
    return 0;
}

int list_sum(const node_t *p) {
    int s = 0;
    for (; p!=NULL; p=p->next)
        s += p->elem;
    return s;
}
