# typedef struct node_t {    // base
#     short elem;            // offset: 0 |xx..|   (base)
#     struct node_t *next;   // offset: 4 |xxxx|  4(base)
# } node_t;                  // sizeof: 8

.globl list_sum

list_sum:   #int list_sum(const node_t *p) {
    movl 4(%esp), %ecx      # const node_t *ecx = p;
    xorl %eax, %eax         # int eax = 0;
L:  testl %ecx, %ecx        # if (ecx==0)
    je E                    #   goto E;
    movw (%ecx), %dx        # eax +=  |  (*ecx).elem;
    movswl %dx, %edx        #     | (int)
    addl %edx, %eax         # ----+
    movl 4(%ecx), %ecx      # ecx = (*ecx).next;
    jmp L                   # goto L;
E:  ret                     # return eax;
